from typing import List, Optional, Any, Sequence, Union, Dict, Type, Callable
import transformers
from langchain_deepseek import ChatDeepSeek
from langchain_core.messages import BaseMessage
from langchain_core.tools import BaseTool

chat_tokenizer_dir = "./"
tokenizer = transformers.AutoTokenizer.from_pretrained(
    chat_tokenizer_dir, trust_remote_code=True
)


class ChatDeepSeekPlus(ChatDeepSeek):
    _tokenizer = transformers.AutoTokenizer.from_pretrained(
        "./", trust_remote_code=True
    )

    def get_num_tokens_from_messages(
        self,
        messages: List[BaseMessage],
        tools: Optional[
            Sequence[Union[Dict[str, Any], Type, Callable, BaseTool]]
        ] = None,
    ) -> int:
        num_tokens = 0
        for msg in messages:
            num_tokens += len(tokenizer.encode(msg.content))
        return num_tokens
